<template>
  <div
    class="rounded-full flex flex-col justify-center"
    @click="drag.click($event)"
    @touchmove="drag.touchMove($event)"
    @touchend="$emit('selected')"
  >
    <div class="stacking pointer-events-none select-none">
      <div
        v-if="values.includes(value)"
        class="flex flex-col justify-center"
        :style="{ transform: `rotate(${rotation(value)}rad)` }"
      >
        <div style="width: calc(50% + (0.5rem /2))" class="stacking">
          <div
            class="bg-blue-500 rounded-full self-center justify-self-end"
            style="width: calc(100% - 0.5rem); height: 2px"
          ></div>
          <div class="flex flex-row justify-between items-center">
            <div class="h-10 w-10 bg-blue-500 rounded-full m-1"></div>
            <div class="h-2 w-2 bg-blue-500 rounded-full"></div>
          </div>
        </div>
      </div>
      <div
        v-for="value of values"
        :key="value"
        class="flex flex-row"
        :style="{ transform: `rotate(${rotation(value)}rad)` }"
      >
        <div
          class="w-10 h-10 rounded-full flex flex-row items-center justify-center m-1"
          :class="isSelected(value) ? 'text-white' : ''"
          :style="{ transform: `rotate(-${rotation(value)}rad)` }"
        >
          <div :style="!isSelected(value) ? `min-height: 0.5rem; min-width: 0.5rem` : ''">
            <span v-if="showFull(value)">{{ value }}</span>
            <div v-else-if="isSelected(value)" class="bg-white h-1 w-1 rounded-full"></div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { watchedRef } from "@/use/watchedRef";
import { nextTick } from "@vue/runtime-core";

export default {
  props: {
    active: {
      type: Boolean
    },
    from: {
      type: Number,
      required: true
    },
    to: {
      type: Number,
      required: true
    },
    shift: {
      type: Number,
      default: 0
    },
    every: {
      type: Number,
      default: 1
    },
    value: {
      required: true
    }
  },
  emits: ["input", "selected"],
  setup(props, context) {
    const values = watchedRef(() => Array.from({ length: props.to - props.from + 1 }, (v, i) => i + props.from));
    const stepsize = watchedRef(() => (2 * Math.PI) / values.value.length);

    const halfpi = Math.PI / 2;
    const doublepi = 2 * Math.PI;
    const rotation = (value: number) =>
      (stepsize.value * (values.value.indexOf(value) + props.shift) + halfpi) % doublepi;
    return {
      values,
      isSelected: (value: number) => props.value == value,
      rotation,
      showFull: (value: number) => values.value.indexOf(value) % props.every == 0,
      drag: {
        click(event: MouseEvent) {
          this.handleInput(event as MouseEvent & { target: HTMLElement });
          setTimeout(() => context.emit("selected"), 100);
        },
        touchMove(event: TouchEvent) {
          event.preventDefault();
          const touch = event.touches[0];
          const target = event.target as HTMLElement;
          this.handleInput({
            target,
            offsetX: touch.clientX - target.offsetLeft,
            offsetY: touch.clientY - target.offsetTop
          });
        },
        getAngleFromCoordinate({ x, y }: { x: number; y: number }) {
          // Middle
          if (x == 0 && y == 0) {
            return Math.PI / 2;
          }
          // Top
          if (x == 0 && y > 0) {
            return Math.PI / 2;
          }
          // Bottom
          if (x == 0 && y < 0) {
            return (3 * Math.PI) / 2;
          }
          // Left
          if (x > 0 && y == 0) {
            return 0;
          }
          // Right
          if (x < 0 && y == 0) {
            return Math.PI;
          }
          if (x >= 0 && y >= 0) {
            // Up left
            return Math.atan(y / x);
          }
          if (x < 0 && y > 0) {
            // Up right
            return 0.5 * Math.PI + Math.atan(-x / y);
          }
          if (x < 0 && y < 0) {
            // Down right
            return 1 * Math.PI + Math.atan(-y / -x);
          }
          // Down left
          return 1.5 * Math.PI + Math.atan(-x / y);
        },
        handleInput({
          offsetX,
          offsetY,
          target: { offsetHeight: height, offsetWidth: width }
        }: {
          target: HTMLElement;
          offsetX: number;
          offsetY: number;
        }) {
          // Origin top left
          const clicked = { x: offsetX / width, y: offsetY / height };
          // Origin on center
          const projected = { x: 0.5 - clicked.x, y: 0.5 - clicked.y };

          const alpha = this.getAngleFromCoordinate(projected);

          let smallest = { diff: Infinity, value: null as null | number };
          for (const value of values.value) {
            const diff = Math.abs(rotation(value) - alpha);
            if (diff < smallest.diff) {
              smallest = { diff, value };
            }
          }
          context.emit("input", smallest.value);
        }
      }
    };
  }
};
</script>

<style></style>
